<?php
 /**
 * 
 *  2016 E-goi  
 *  All Rights Reserved.
 * 
 */
include_once dirname(__FILE__).'/../abstract/PSEgoiController.php';

class FormsController extends PSEgoiController {

	public function __construct() {

		$this->display = 'E-goi - My Forms';
		$this->bootstrap = true;
		parent::__construct();

		$this->meta_title = $this->l('E-goi Forms').' - '.$this->module->displayName;
		if (!$this->module->active)
			Tools::redirectAdmin($this->context->link->getAdminLink('AdminHome'));
		
	}
	
	public function initContent() {

		$error_msg = '';
		
		parent::initContent();
		
		if($this->hasApiKey) {

			$msg = '';
			if(!empty($_POST)){
				$msg = $this->postForm();
			}

			$api = new EgoiAPIV2();

			$data_lists = $api->getLists();
			$this->assign('lists', $data_lists);

			$sql = 'SELECT COUNT(*) AS COUNT FROM '._DB_PREFIX_.'egoi_forms';
			$count = Db::getInstance(_PS_USE_SQL_SLAVE_)->executeS($sql);
			$count_data = $count[0]['COUNT'];
			$this->assign('count', $count_data);

			$sql_view = 'SELECT * FROM '._DB_PREFIX_.'egoi_forms';
			$vw = Db::getInstance(_PS_USE_SQL_SLAVE_)->executeS($sql_view);
			$this->assign('ps_forms', $vw);
			$view = isset($vw[0]) ? $vw[0] : '';

			$list_id = isset($view['list_id']) ? $view['list_id'] : false;
			
			if($list_id){

				$content = $view['content'];
				$this->assign('form_content', $content);

				$this->assign('list_id', $list_id);

				$forms = $api->getForms($list_id);
				$this->assign('forms', $forms);

			}

			$type = isset($_GET['type']) ? $_GET['type'] : '';
			$this->assign('type', $type);

			$form = isset($_GET['form']) ? $_GET['form'] : false;
			$this->assign('form', $form);

			$token = $_GET['token'];
			$this->assign('token', $token);

			if($msg){
				$this->assign('egoi_success_message', 1);
			}else if($msg === false){
				$this->assign('egoi_error_message', $msg);
			}
		}

		return $this->displayForm($form, $this->hasApiKey);
				
	}

	public function displayForm($form = false, $display = false) {

		if($form || $display){
			$sql_form = "SELECT * FROM "._DB_PREFIX_."egoi_forms WHERE form_id='".(int)$form."'";
			$getforms = Db::getInstance(_PS_USE_SQL_SLAVE_)->executeS($sql_form);
			$forms = isset($getforms[0]) ? $getforms[0] : array('enable' => '', 'form_title' => '', 'content' => '', 'boot' => '', 'msg_gen' => '', 'msg_invalid' => '',
						'msg_exists' => '', 'success' => '', 'redirect' => '', 'style_width' => '', 'style_height' => '', 'block_header' => '', 'block_footer' => '', 
						'block_home' => '', 'popup' => '', 'once' => '', 'url' => '', 'hide' => '0'
					);

			if($forms){
				$this->assign('enable', $forms['enable']);
				$this->assign('form_title', $forms['form_title']);
				$this->assign('form_content', $forms['content']);
				$this->assign('boot', $forms['boot']);
				$this->assign('msg_gen', $forms['msg_gen']);
				$this->assign('msg_invalid', $forms['msg_invalid']);
				$this->assign('msg_exists', $forms['msg_exists']);
				$this->assign('success', $forms['success']);
				$this->assign('redirect', $forms['redirect']);

				$this->assign('style_width', $forms['style_width']);
				$this->assign('style_height', $forms['style_height']);

				$this->assign('header', $forms['block_header']);
				$this->assign('footer', $forms['block_footer']);
				$this->assign('home', $forms['block_home']);
				$this->assign('popup', $forms['popup']);
				$this->assign('once', $forms['once']);
				$this->assign('form_data', $forms['url']);
				$this->assign('url', $forms['url']);
				$this->assign('hide', $forms['hide']);
			}

			$this->assign('content', $this->fetch('forms.tpl'));
		}else{
			$this->assign('content', $this->fetch('ErrorApiKey.tpl'));
		}

	}

	public function postForm() {

		if(isset($_POST['form_title'])){
			
			$post = $_POST;
			$enable = $post['enable'];
			$list = $post['list'];
			//$doptin = $post['doptin'];
			$form_id = $post['form_id'];
			$form_content = isset($post['form_content']) ? htmlentities($post['form_content']) : '';
			$form_title = $post['form_title'];
			$boot = isset($post['boot']) ? $post['boot'] : '';
			
			//$formID_egoi = $post['form'];
			$form_type = $post['form_type'];
			$url = $post['form'];

			$msg_gen = isset($post['msg_gen']) ? $post['msg_gen'] : '';
			$msg_invalid = isset($post['msg_invalid']) ? $post['msg_invalid'] : '';
			$msg_exists = isset($post['msg_exists']) ? $post['msg_exists'] : '';
			$success = isset($post['success']) ? $post['success'] : '';
			$redirect = $post['redirect'];
			$hide = $post['hide'];

			$style_width = $post['style_width'];
			$style_height = $post['style_height'];
			
			$header = $post['header'];
			$footer = $post['footer'];
			$home = $post['home'];
			$popup = $post['popup'];
			$once = $post['once'];

			$status = '1';

			$api = new EgoiAPIV2();
			$client_data = $api->getClientData();
			$client = $client_data['CLIENTE_ID'];
			
			$check = 'SELECT * FROM '._DB_PREFIX_.'egoi_forms WHERE form_id='.(int)$form_id;
			$query = Db::getInstance(_PS_USE_SQL_SLAVE_)->executeS($check);

				$insert = '';
				$update = '';
				$sql_insert = array(
					'enable' => (int)$enable,
					'list_id' => (int)$list,
					'client_id' => (int)$client,
					'form_id' => (int)$form_id,
					'form_title' => pSQL($form_title),
					'content' => pSQL($form_content),
					'doptin' => 0,
					'boot' => pSQL($boot),
					'msg_gen' => pSQL($msg_gen),
					'msg_invalid' => pSQL($msg_invalid),
					'msg_exists' => pSQL($msg_exists),
					'success' => pSQL($success),
					'redirect' => pSQL($redirect),
					'hide' => isset($hide) ? pSQL($hide) : 0,
					'style_width' => pSQL($style_width),
					'style_height' => pSQL($style_height),
					'block_header' => pSQL($header),
                    'block_banner' => 0,
					'block_footer' => pSQL($footer),
					'block_home' => pSQL($home),
					'popup' => pSQL($popup),
					'once' => pSQL($once),
					'url' => pSQL($url),
					'form_type' => pSQL($form_type),
					'estado' => (int)$status
				);

				if($query[0]['form_id']) {
					
					$where = "form_id = ".(int)$form_id;
					$update = Db::getInstance()->update('egoi_forms', $sql_insert, $where);
				}else{
					$insert = Db::getInstance()->insert('egoi_forms', $sql_insert);
				}

			if($insert || $update){
				$msg = 1;
				return $msg;
			}
			return false;
		}
			
	}

}
