<?php
 /**
 * 
 *  2016 E-goi  
 *  All Rights Reserved.
 * 
 */
include_once dirname(__FILE__).'/../abstract/PSEgoiController.php';

class ListsController extends PSEgoiController {

	public function __construct() {
		
		$this->display = 'E-goi - My Lists';
		$this->bootstrap = true;
		parent::__construct();
		$this->meta_title = $this->l('My Lists').' - '.$this->module->displayName;
		if (!$this->module->active)
			Tools::redirectAdmin($this->context->link->getAdminLink('AdminHome'));
	}
	
	public function initContent() {

		parent::initContent();

		$msg = '';
		if(!empty($_POST)){
			$msg = $this->postList();
		}
				
		if($this->hasApiKey) {
			$api = new EgoiAPIV2();
			if($data = $api->getLists()) {
				$this->assign('lists', $data);
			} else {
				$this->assign('lists', false);
			}
		}

		if($msg){
			if(is_numeric($msg)){
				$this->assign('egoi_success_message', $msg);
			}else{
				$this->assign('egoi_error_message', $msg);
			}
		}
		
		$url_list = '/?action=lista_definicoes_principal&list=';
		$this->assign('url_list', $url_list);
		
		$this->content .= $this->fetch('lists.tpl');
		$this->assign('content', $this->content);
	}
	
	public function postList() {

		$list = $_POST;

		$name = $list['egoi_ps_title'];
		$lang = $list['egoi_ps_lang'];

		$api = new EgoiAPIV2();
		$result = $api->createList($name, $lang);
		if($result){
			return $result;
		}
		return false;

	}
	
	
}
