<?php
 /**
 * 
 *  2016 E-goi  
 *  All Rights Reserved.
 * 
 */
include_once dirname(__FILE__).'/../abstract/PSEgoiController.php';

class SubscribersController extends PSEgoiController {

	public function __construct() {

		$this->name = 'egoiforps';
		$this->display = 'E-goi - My Subscribers';
		$this->pathurl = '/views/templates/admin/img/mysubscribers.png';
		$this->bootstrap = true;
		parent::__construct();
		$this->meta_title = $this->l('E-goi Subscribers').' - '.$this->module->displayName;
		if (!$this->module->active)
			Tools::redirectAdmin($this->context->link->getAdminLink('AdminHome'));
		$this->retrieveRoles();

		$this->mapFieldsEgoi();

		$this->syncronizeEgoi($_POST);
		
	}


	public function initContent() {
	
		parent::initContent();
		
		if($this->hasApiKey) {
			
			$msg = '';
			if(!empty($_POST)){
				$msg = $this->postList();
			}

			$api = new EgoiAPIV2();

			$data_lists = $api->getLists();
			$this->assign('lists', $data_lists);

			$sql = 'SELECT * FROM '._DB_PREFIX_.'egoi where client_id!="" order by egoi_id DESC limit 1';
			$rq = Db::getInstance(_PS_USE_SQL_SLAVE_)->executeS($sql);
			
			if(!empty($rq[0])){
				$list_id = $rq[0]['list_id'];
				$sync = $rq[0]['sync'];
				$track = $rq[0]['track'];
				$role = $rq[0]['role'];
			}

			if(isset($list_id) && ($list_id)){
				
				$data_subs = $api->getSubscribersFromListId($list_id);
				$this->assign('subscribers', $data_subs);
				$this->assign('list_id', $list_id);
				$this->assign('sync', $sync);
				$this->assign('track', $track);
				$this->assign('role_id', $role);
				$this->assign('pathurl', $this->pathurl);

				$forms = $api->getForms($list_id);
				$this->assign('forms', $forms);

				//map fields
				$egoi_fields = array(
					'first_name' => 'First name',
					'last_name' => 'Last name',
					'surname' => 'Surname',
					'cellphone' => 'Mobile',
					'telephone' => 'Telephone',
					'birth_date' => 'Birth Date'
				);

				$extra = $api->getExtraFields($list_id);
				foreach($extra as $key => $extra_field){
					$egoi_fields['extra_'.$key] = $extra_field['NAME'];
				}
				
				$option = '';
				foreach($egoi_fields as $key => $field){
					$option .= '<option value='.$key.'>'.$field.'</option>'.PHP_EOL;
				}

				$this->assign('select', $option);
				
				$mapped_fields = $api->getMappedFields();
				$this->assign('mapped_fields', $mapped_fields);
			}

			$token = $_GET['token'];
			$this->assign('token', $token);

			$this->assign('egoi_success_message', $msg);
		}

		$this->content .= $this->fetch('subs.tpl');
		$this->assign('content', $this->content);
		
	}

	public function postList() {

		$submit = $_POST['action_add'];

		if(isset($submit)){

			$post = $_POST;
			$list = $post['list'];
			$sync = $post['enable'];
			$role = $post['role'];
			$track = $post['track'];
			$estado = 1;
			
			$update = '';
			$insert = '';

			if($track == ''){
				$track = 1;
			}

			$api = new EgoiAPIV2();
			$client_data = $api->getClientData();
			$client = $client_data['CLIENTE_ID'];
			
			$check = 'SELECT * FROM '._DB_PREFIX_.'egoi WHERE client_id='.(int)$client;

			$query = Db::getInstance(_PS_USE_SQL_SLAVE_)->executeS($check);

			$sql_insert = array(
				'list_id' => (int)$list, 
				'client_id' => (int)$client,
				'sync' => (int)$sync,
				'track' => (int)$track,
				'role' => pSQL($role),
				'estado' => (int)$estado,
                'total' => 0
			);

			if($query[0]['client_id']) {
				$where = "client_id = ".(int)$client;
				$update = Db::getInstance()->update('egoi', $sql_insert, $where);
			}else{
				$insert = Db::getInstance()->insert('egoi', $sql_insert);
			}

			if($insert || $update){
				$msg = 1;
				return $msg;
			}

		}else{
			return false;
		}
	}

	public function retrieveRoles(){

		$groups = Group::getGroups(Context::getContext()->language->id, true);
		$this->assign('roles', $groups);
	}

	//E-goi Map Fields
	public function mapFieldsEgoi() {

		$id = isset($_POST["id_egoi"]) ? $_POST["id_egoi"] : '';
		$token = isset($_POST["token_egoi_api"]) ? (int)$_POST["token_egoi_api"] : '';
		$ps = isset($_POST["ps"]) ? $_POST["ps"] : '';
		$egoi = isset($_POST["egoi"]) ? $_POST["egoi"] : '';

		if(($token) && ($ps) && ($egoi)){

			$ps_name = $_POST["ps_name"];
			$egoi_name = $_POST["egoi_name"];
			$status = 1;

			$sql_exists = "SELECT id FROM "._DB_PREFIX_."egoi_map_fields WHERE ps='".pSQL($ps)."' OR egoi='".pSQL($egoi)."'";
			$exists = Db::getInstance()->executeS($sql_exists);
			$field_exist = isset($exists[0]) ? $exists[0] : false;

			if (!$field_exist){

				$values = array(
					'ps' => pSQL($ps),
					'ps_name' => pSQL($ps_name),
					'egoi' => pSQL($egoi),
					'egoi_name' => pSQL($egoi_name),
					'status' => (int)$status
				);

				Db::getInstance()->insert('egoi_map_fields', $values);

			 	$sql="SELECT * FROM "._DB_PREFIX_."egoi_map_fields order by id DESC LIMIT 1";
	         	$rows = Db::getInstance(_PS_USE_SQL_SLAVE_)->executeS($sql);

	         	foreach ($rows as $post){
	         		$this->assign('post_id', $post['id']);
	         		$this->assign('ps_name', $post['ps_name']);
	         		$this->assign('egoi_name', $post['egoi_name']);

	         		echo $this->context->smarty->display(_PS_MODULE_DIR_.$this->name.'/views/templates/admin/fields.tpl');
	         	}

	        }

			exit;

		}else if($id){

			Db::getInstance()->delete('egoi_map_fields', 'id = '.(int)$id);
			exit;
		}
	}

	private function getEgoiSubscribers($listID){

		$count = 0;
		$api = new EgoiAPIV2();
		$result = $api->getLists();

		foreach ($result as $key => $value) {
			if($value['listnum'] == $listID){
				$count = $value['subs_activos'];
			}
		}

	    return $count;
	}

	public function syncronizeEgoi($post = array()){

		if(!empty($post)){
			if(isset($post['action']) && ($post['action'] == 'synchronize')){
				$all_subscribers = $this->getEgoiSubscribers($post['list']);
				
				$total = array();
				$sql_cust = 'SELECT COUNT(*) AS CT FROM '._DB_PREFIX_.'customer WHERE active="1"';
				$exec = Db::getInstance()->executeS($sql_cust);
				$total_ps = $exec[0]['CT'];

				$total[] = $all_subscribers;
				$total[] = $total_ps;

				echo json_encode($total);
				exit;
			}
		}
	}
	
}