<?php error_reporting(0);
if (!defined('_PS_VERSION_'))
  exit;

class EgoiforPs extends Module {

    const SMS_NOTIFICATIONS_SENDER_CONFIGURATION = 'sms_notifications_sender';
    const SMS_NOTIFICATIONS_ADMINISTRATOR_CONFIGURATION = 'sms_notifications_administrator';
    const SMS_NOTIFICATIONS_ADMINISTRATOR_PREFIX_CONFIGURATION = 'sms_notifications_administrator_prefix';
    const SMS_NOTIFICATIONS_DELIVERY_ADDRESS_CONFIGURATION = 'sms_notifications_delivery_address';
    const SMS_NOTIFICATIONS_INVOICE_ADDRESS_CONFIGURATION = 'sms_notifications_invoice_address';
    const SMS_REMINDER_DEFAULT_TIME_CONFIG = 'sms_reminder_default_time_config';

    const SMS_MESSAGES_DEFAULT_LANG_CONFIGURATION = 'sms_messages_default_lang';
    const SMS_REMINDERS_DEFAULT_LANG_CONFIGURATION = 'sms_reminders_default_lang';

    const CUSTOM_INFO_DELIMITER = '%';
    const CUSTOM_INFO_ORDER_REFERENCE = self::CUSTOM_INFO_DELIMITER . 'order_reference' . self::CUSTOM_INFO_DELIMITER;
    const CUSTOM_INFO_ORDER_STATUS = self::CUSTOM_INFO_DELIMITER . 'order_status' . self::CUSTOM_INFO_DELIMITER;
    const CUSTOM_INFO_TOTAL_COST = self::CUSTOM_INFO_DELIMITER . 'total_cost' . self::CUSTOM_INFO_DELIMITER;
    const CUSTOM_INFO_CURRENCY = self::CUSTOM_INFO_DELIMITER . 'currency' . self::CUSTOM_INFO_DELIMITER;
    const CUSTOM_INFO_ENTITY = self::CUSTOM_INFO_DELIMITER . 'entity' . self::CUSTOM_INFO_DELIMITER;
    const CUSTOM_INFO_MB_REFERENCE = self::CUSTOM_INFO_DELIMITER . 'mb_reference' . self::CUSTOM_INFO_DELIMITER;
    const CUSTOM_INFO_SHOP_NAME = self::CUSTOM_INFO_DELIMITER . 'shop_name' . self::CUSTOM_INFO_DELIMITER;
    const CUSTOM_INFO_BILLING_NAME = self::CUSTOM_INFO_DELIMITER . 'billing_name' . self::CUSTOM_INFO_DELIMITER;

    const PAYMENT_MODULE_IFTHENPAY = 'multibanco';
    const PAYMENT_MODULE_EUPAGO = 'eupago_multibanco';
    const PAYMENT_STATUS_WAITING_MB_PAYMENT = 'waiting_mb_payment';

    const LIMIT_HOUR_MIN = 10;
    const LIMIT_HOUR_MAX = 22;

	private $custom_file_path = '/../../override/classes/WebserviceSpecificManagementEgoi.php';

    /**
     * Transactional API
     *
     * @var $transactionalApi
     */
    protected $transactionalApi;

	public function __construct() {

		if(!session_id()){
			session_start();
		}

	    $this->name = 'egoiforps';
	    $this->tab = 'advertising_marketing';
	    $this->version = '1.3.1';
	    $this->author = 'E-goi';
	    $this->need_instance = 1;
	    $this->ps_versions_compliancy = array('min' => '1.5', 'max' => _PS_VERSION_);
	    $this->bootstrap = true;
	    $this->module_key = 'de273f979eced5e000557ccab3a28fc8';

	    $this->jspath = 'views/js/';
        $this->csspath = 'views/css/';

        $this->load_class = 'controllers/admin/SubscribersController.php';
        $this->load_front = 'controllers/front/egoi_forms.php';
        $this->api_class = 'classes/EgoiAPIV2.php';
        $context = Context::getContext();
        $this->context = $context;

	    parent::__construct();

	    $this->displayName = $this->l('Smart Marketing');
	    $this->description = $this->l('E-goi Syncronization for Lists and Subscribers');

	    $this->confirmUninstall = $this->l('Are you sure you want to uninstall?');

		if(isset($_GET['token']))
			$this->hookHeader();

		if(isset($_POST['deleteMode']) && ($_POST['deleteMode'] == 'real')){
			$this->customerDelete();
		}

		if(isset($_GET['conf']) && ($_GET['conf'] == '4')) {
			$this->customerUpdate();
		}

		$this->_errors = array();
		$this->error = false;

		$this->registerHook('displayBackOfficeHeader');

		$this->registerHook('displayHome');
		$this->registerHook('displayHeader');

		//hooks for abandoned cart
		$this->registerHook('cart');
		$this->registerHook('actionCartSave');
		
		if(isset($_GET['id_cart']) && ($_GET['id_order']) && ($_GET['key'])) {
			$this->finalOrder();
		}

		if(isset($_POST['form_id']) && (isset($_POST['email']) && ($_POST['email']))) {
			$this->postFrontForm($_POST);
		}

		if(isset($_POST['token_list']) && ($_POST['token_list'])){
			$this->sincronizeList($_POST);
		}

		spl_autoload_register(array($this, 'autoload'));

        $this->transactionalApi = new TransactionalApi();

		if(isset($_POST['egoi_api_key']) && ($_POST['egoi_api_key'])){
			$this->addClientId($_POST);
		}

		// validate api key
		$this->validateApiKey();
	}

   	public function autoload($classname) {

        $classFile = dirname(__FILE__).'/classes/'.$classname.'.php';
        if(is_file($classFile)){
            include_once $classFile;
        }

        include_once dirname(__FILE__).'/classes/EgoiRestApi.php';
        include_once dirname(__FILE__).'/classes/ApiV3.php';
        include_once dirname(__FILE__).'/classes/TransactionalApi.php';
    }

    public function registerWebService() {
    	
		$sql = array(
			'key' => md5(time()),
			'class_name' => "WebserviceRequest",
			'description' => "E-goi",
			'active' => 1
		);
		Db::getInstance()->insert('webservice_account', $sql);

		$sql = 'SELECT id_webservice_account FROM '._DB_PREFIX_.'webservice_account WHERE description="E-goi"';
		$row = Db::getInstance()->execute($sql);

		if(!empty($row)) {
			$id_webservice = $row[0]['id_webservice_account'];

			// add webservice relation
			Db::getInstance()->insert('webservice_account_shop', 
				array(
					'id_webservice_account' => $id_webservice,
					'id_shop' => 1,
				)
			);

			// assign webservice permissions
			Db::getInstance()->insert('webservice_permission', 
				array(
					'id_webservice_account' => $id_webservice,
					'resource' => 'egoi',
					'method' => "GET",
				)
			);

			// process custom overrides
			$this->installEgoiOverrides();

			return true;
		}

		return false;
	}

	public function uninstallWebService() {

		$sql = 'SELECT id_webservice_account FROM '._DB_PREFIX_.'webservice_account WHERE description="E-goi"';
		$row = Db::getInstance()->execute($sql);

		if(!empty($row)) {
			$id_webservice = $row[0]['id_webservice_account'];
			$sql = 'DELETE FROM '._DB_PREFIX_.'webservice_account WHERE id_webservice_account="'.$id_webservice.'"';
			Db::getInstance()->execute($sql);

			// remove webservice from Shop
			$sql = 'DELETE FROM '._DB_PREFIX_.'webservice_account_shop WHERE id_webservice_account="'.$id_webservice.'"';
			Db::getInstance()->execute($sql);

			// remove webservice permissions
			$sql = 'DELETE FROM '._DB_PREFIX_.'webservice_permission WHERE id_webservice_account="'.$id_webservice.'"';
			Db::getInstance()->execute($sql);

			return true;
		}

		return false;
	}

	public function install() {

	  	if (!parent::install() || !$this->installDb() || !$this->createMenu()
	  		|| !$this->registerHook('actionObjectCustomerAddAfter')
	  		|| !$this->registerHook('actionValidateOrder')
	  		|| !$this->registerHook('displayTop')
	  		|| !$this->registerHook('displayFooter')
            || !$this->registerHook('actionDispatcher')
            || !$this->registerHook('actionOrderStatusPostUpdate')) {
	    	return false;
	  	}

		// register WebService
		$this->registerWebService();
	  	return true;
	}

	public function uninstall() {

	  	if (!parent::uninstall() || !$this->uninstallDb() || !$this->deleteMenu()){
	    	return false;
	  	}

	  	// remove overrides
	  	$this->uninstallEgoiOverrides();

	  	// remove webservice
	  	$this->uninstallWebService();

		$email = $this->context->cookie->email;
	  	$this->serviceActivate($email, 2);
	  	return true;
	}

	public function hookHeader() {

		$this->context->controller->addJquery();
		$this->context->controller->addJS(($this->_path.$this->jspath). 'requestAjax.js');
		$this->context->controller->addJS(($this->_path.$this->jspath). 'ajaxSync.js');
		$this->context->controller->addJS(($this->_path.$this->jspath). 'map_fields.js');
		
		if(isset($_GET['form']) && ($_GET['form'])){
			$this->context->controller->addJS(($this->_path.$this->jspath). 'forms.js');
			$this->context->controller->addJS(($this->_path.$this->jspath). 'formsFunctions.js');
		}

        if(!empty($_GET['messages']) || !empty($_GET['reminders'])){
            $this->context->controller->addJS(($this->_path.$this->jspath). 'sms-notifications/messages.js');
        }

		$this->context->controller->addCSS(($this->_path.$this->csspath). 'main.css');
    }

    /*
    * Assign content to PS
    */
    private function assign($values) {

    	if(isset($values) && is_array($values)){
	        foreach ($values as $key => $value) {
	        	$this->smarty->assign($key, $value);
	        }
	    }
    }

    /**
     * Process Overrides
     * @return bool
     */
    private function installEgoiOverrides()
    {
    	exec('cp '.dirname(__FILE__).'/override/classes/webservice/WebserviceSpecificManagementEgoi.php '.dirname(__FILE__).'/../../override/classes/webservice/');
		exec('rm -f '.dirname(__FILE__).'/../../cache/class_index.php');
    	return true;
    }

    /**
     * Remove overrides
     */
    private function uninstallEgoiOverrides()
    {
    	exec('rm -f '.dirname(__FILE__).'/../../override/classes/webservice/WebserviceSpecificManagementEgoi.php');
    }

    /**
     * Returns the payment module key from order
     *
     * @param $orderState
     *
     * @return bool|string
     */
    public static function getPaymentModule($orderState)
    {
        if (self::isPaymentIfthenPay($orderState)) {
            return self::PAYMENT_MODULE_IFTHENPAY;
        }

        if (self::isPaymentEuPago($orderState)) {
            return self::PAYMENT_MODULE_EUPAGO;
        }

        return false;
    }

    /**
     * Checks if payment is from ifThenPay module
     *
     * @param $orderState
     *
     * @return bool
     */
    private static function isPaymentIfthenPay($orderState)
    {
        $orderState = (array)$orderState;
        if ($orderState['template'] == 'multibanco') {
            return true;
        }

        return false;
    }

    /**
     * Checks if payment is from euPago module
     *
     * @param $orderState
     *
     * @return bool
     */
    private static function isPaymentEuPago($orderState)
    {
        $search = 'euPago';
        $orderState = (array)$orderState;
        if (substr($orderState['name'], 0, strlen($search)) === $search && $orderState['template'] == '') {
            return true;
        }

        return false;
    }

    /*
    *
    * Module admin page
    */
	public function getContent() {

	   $output = '';
        if (!extension_loaded('soap')) {

            $output .= '<fieldset>
                        <p><b>PHP SOAP LIBRARY: </b> <span style="color: red">'.$this->l('NOT LOADED').'</span></p>
                        <p>'.$this->l('Your website sever has not loaded PHP SOAP library required to use integration with E-goi Email Marketing.').'</p>
                        <p>'.$this->l('Please ask your server\'s administrator who will install the PHP SOAP library.').'</p>
                        </fieldset>';
            return $output;

        }else{

        	$msg = '';
            $error_msg = '';
            if (Tools::getIsset('submitUpdate')) {
                if (Tools::getValue('egoi_api_key') == NULL)
                    $this->_errors[] = $this->l('Indicate Correct API key.');

                if (!sizeof($this->_errors)) {
                    Configuration::updateValue('egoi_api_key', (Tools::getValue('egoi_api_key')));
                    $this->transactionalApi = new TransactionalApi();
                    $this->transactionalApi->enableClient();
                    $msg = $this->l('API Key saved and updated');
                } else {
                    foreach ($this->_errors AS $error)
                        $error_msg .= $error.'<br />';
                    $error_msg =  $this->displayError($error_msg);
                }
                $this->serviceActivate($this->context->cookie->email, true, 'validate');

            }

            $this->smarty->assign('egoi_success_message', $msg);
            $this->smarty->assign('egoi_error_message', $error_msg);
            $this->smarty->assign('egoi_has_error', $this->error);

            $this->smarty->assign('ShowApiKeyWarn', Configuration::get('egoi_api_key')?false:true);
            $this->smarty->assign('egoi_title', $this->displayName);
            $this->smarty->assign('egoi_version', $this->version);

            return $this->display($this->name, 'views/templates/admin/config.tpl');
        }
	}

	public function displayForm() {

	    $default_lang = (int)Configuration::get('PS_LANG_DEFAULT');
	    $helper = new HelperForm();

	    // Module, token and currentIndex
	    $helper->module = $this;
	    $helper->name_controller = $this->name;
	    $helper->token = Tools::getAdminTokenLite('AdminModules');
	    $helper->currentIndex = AdminController::$currentIndex.'&configure='.$this->name;

	    // Language
	    $helper->default_form_language = $default_lang;
	    $helper->allow_employee_form_lang = $default_lang;

	    // Title and toolbar
	    $helper->title = $this->displayName;
	    $helper->show_toolbar = true;
	    $helper->toolbar_scroll = true;
	    $helper->submit_action = 'submit'.$this->name;
	    $helper->toolbar_btn = array(
		'save' =>
			array(
			    'desc' => $this->l('Save'),
			    'href' => AdminController::$currentIndex.'&configure='.$this->name.'&save'.$this->name.
			    '&token='.Tools::getAdminTokenLite('AdminModules'),
			),
			'back' => array(
			    'href' => AdminController::$currentIndex.'&token='.Tools::getAdminTokenLite('AdminModules'),
			    'desc' => $this->l('Back to list')
			)
	    );

        $this->smarty->assign('egoi_has_error', $this->error);
        $this->smarty->assign('ShowApiKeyWarn', Configuration::get('egoi_api_key') ? false : true);
        $this->smarty->assign('egoi_title', $this->displayName);
        $this->smarty->assign('egoi_version', $this->version);

	    // Load current value
	    $helper->fields_value['egoi_api_key'] = Configuration::get('egoi_api_key');

	    return $this->display($this->name, 'views/templates/admin/config.tpl');
	}


	private function createMenu() {

		$mainTab = Tab::getInstanceFromClassName('EgoiforPs');

		$subtabs = array(
			'Account' => array('1'=> $this->l('My Account')),
			'Lists' => array('1' => $this->l('My Lists')),
           	'Subscribers' => array('1' => $this->l('My Subscribers')),
			'Forms' => array('1' => $this->l('My Forms')),
            'Notifications' => array('1' => $this->l('My SMS Notifications')),
		);

		$res = true;

		if(!Validate::isLoadedObject($mainTab)) {
			$mainTab->active = 1;
			$mainTab->class_name = 'EgoiforPs';
			$mainTab->id_parent = 0;
			$mainTab->module = $this->name;
			$mainTab->name = $this->createMultiLangField('Smart Marketing');
			$res &= $mainTab->save();
			$mainTab = Tab::getInstanceFromClassName('EgoiforPs');
		}

		if($subtabs)
    		foreach($subtabs as $className => $menuName) {
    			$res &= $this->createSubmenu($mainTab->id, $menuName, $className);
    		}

		return $res;
	}

	private function createSubmenu($parentId, $menuName, $className) {

		$subTab = Tab::getInstanceFromClassName($className);
		if(!Validate::isLoadedObject($subTab)) {
			$subTab->active = 1;
			$subTab->class_name = $className;
			$subTab->id_parent = $parentId;
			$subTab->module = $this->name;
			$subTab->name = $this->createMultiLangFieldHard($menuName);
			return $subTab->save();
		} elseif($subTab->id_parent != $parentId) {
			$subTab->id_parent = $parentId;
			return $subTab->save();
		}
		return true;
	}

	private function deleteMenu() {

		Tab::getInstanceFromClassName('EgoiforPs');
		$subtabs = array(
			'Account',
			'Lists',
            'Subscribers',
            'Forms',
            'SmsNotifications'
		);
		$res = true;

		if($subtabs){
			foreach($subtabs as $className) {
				$res &= $this->deleteSubmenu($className);
			}
        }

        return true;
	}

	private function deleteSubmenu($className) {

		$subTab = Tab::getInstanceFromClassName($className);
		return $subTab->delete();
	}

	public function getTranslation($params, $smarty = false) {

        $trans = array(
            'CLIENTE_ID' => $this->l('Client Id'),
            'COMPANY_NAME' => $this->l('Company Name'),
            'COMPANY_LEGAL_NAME' => $this->l('Company Legal Name'),
            'COMPANY_TYPE' => $this->l('Company Type'),
            'BUSINESS_ACTIVITY_CODE' => $this->l('Business Activity Code'),
            'DATE_REGISTRATION' => $this->l('Date Registration'),
            'COUNTRY' => $this->l('Country'),
            'STATE' => $this->l('State'),
            'CITY' => $this->l('City'),
            'ADDRESS' => $this->l('Address'),
            'WEBSITE' => $this->l('Website'),
            'SIGNUP_DATE' => $this->l('Signup Date'),
            'CREDITS' => $this->l('Credits'),
        );

        $key = $params['l'];

        if(array_key_exists($key, $trans)){
            return $trans[$key];
        }else{
            return $key;
        }
    }

    public function installDb() {

		$return = true;
		$sql = array();
		include(dirname(__FILE__).'/installSQL.php');
		foreach ($sql as $s){
		    $return &= Db::getInstance()->execute($s);
		}

        if ($return) {
            $this->mapOrderStateTemplates();
        }

        return $return;
    }

	public function uninstallDb() {

   		include(dirname(__FILE__).'/installSQL.php');
    	foreach ($sql as $name => $v){
       		Db::getInstance()->execute('DROP TABLE IF EXISTS '.$name);
   		}

   		$module = "module = '$this->name'";
   		Db::getInstance()->delete('tab', $module);

   		Configuration::deleteByName('egoi_api_key');

        Configuration::deleteByName(self::SMS_NOTIFICATIONS_SENDER_CONFIGURATION);
        Configuration::deleteByName(self::SMS_NOTIFICATIONS_ADMINISTRATOR_CONFIGURATION);

   		// remove custom override file
   		@unlink(dirname(__FILE__).$this->custom_file_path); 
    	return true;
	}

    private function mapOrderStateTemplates()
    {
        $orderState = new OrderState($this->context->language->id);
        $orderStates = $orderState->getOrderStates($this->context->language->id);
        $langs = Language::getLanguages(true, $this->context->shop->id);


        $orderStateTemplates = $this->getOrderStateTemplates();
        foreach ($orderStates as $orderState) {
            $paymentMod = self::getPaymentModule($orderState);
            if ($paymentMod) {
                $orderState['template'] = self::PAYMENT_STATUS_WAITING_MB_PAYMENT;
                $this->mapReminderLangs($langs, $orderState);
            }
            if (isset($orderStateTemplates[$orderState['template']])) {
                $this->mapOrderStateTemplateLangs($langs, $orderStateTemplates[$orderState['template']], $orderState);
            }
        }
    }

    private function mapOrderStateTemplateLangs($langs, $template, $orderState)
    {
        foreach ($langs as $lang) {
            if (isset($template[$lang['iso_code']])) {
                $clientMessage = $template[$lang['iso_code']]['client'];
                $adminMessage = $template[$lang['iso_code']]['admin'];
            } else {
                $clientMessage = $template['en']['client'];
                $adminMessage = $template['en']['admin'];
            }

            Db::getInstance()->insert(
                'egoi_sms_notif_messages',
                array(
                    'order_status_id' => $orderState['id_order_state'],
                    'lang_id' => $lang['id_lang'],
                    'client_message' => $clientMessage,
                    'admin_message' => $adminMessage
                )
            );
        }
    }

    private function mapReminderLangs($langs, $orderState)
    {
        $reminderTemplates = $this->getReminderTemplates();
        foreach ($langs as $lang) {
            if (isset($reminderTemplates[$lang['iso_code']])) {
                $message = $reminderTemplates[$lang['iso_code']];
            } else {
                $message = $reminderTemplates['en'];
            }

            Db::getInstance()->insert(
                'egoi_sms_notif_reminder_messages',
                array(
                    'order_status_id' => $orderState['id_order_state'],
                    'lang_id' => $lang['id_lang'],
                    'message' => $message,
                    'active' => 0
                )
            );
        }
    }

    private function getReminderTemplates()
    {
        return array(
            'en' => 'Hi, ' . self::CUSTOM_INFO_BILLING_NAME . '! MB payment details for your order at '
                . self::CUSTOM_INFO_SHOP_NAME . '. Ent.: '
                . self::CUSTOM_INFO_ENTITY . ' Ref.: ' . self::CUSTOM_INFO_MB_REFERENCE . ' Amount: '
                . self::CUSTOM_INFO_TOTAL_COST . self::CUSTOM_INFO_CURRENCY . ' Thanks!',
            'pt' => 'Olá, ' . self::CUSTOM_INFO_BILLING_NAME . '! Aguardamos o pagamento por MB do pedido que fez na '
                . self::CUSTOM_INFO_SHOP_NAME . '. Ent.: '
                . self::CUSTOM_INFO_ENTITY . ' Ref.: ' . self::CUSTOM_INFO_MB_REFERENCE . ' Valor: '
                . self::CUSTOM_INFO_TOTAL_COST . self::CUSTOM_INFO_CURRENCY . ' Obrigado!',
            'es' => 'Hola ' . self::CUSTOM_INFO_BILLING_NAME . ', Datos para el pago vía MB de tu pedido en '
                . self::CUSTOM_INFO_SHOP_NAME . '. Ent.: '
                . self::CUSTOM_INFO_ENTITY . ' Ref.: ' . self::CUSTOM_INFO_MB_REFERENCE . ' Importe: '
                . self::CUSTOM_INFO_TOTAL_COST . self::CUSTOM_INFO_CURRENCY . ' ¡Gracias!'
        );
    }

    private function getOrderStateTemplates()
    {
        return array(
            'cheque' => array(
                'en' => array(
                    'client' => 'Hi, ' . self::CUSTOM_INFO_BILLING_NAME . '! We\'re waiting for the payment of your order at ' . self::CUSTOM_INFO_SHOP_NAME . '. Amount to pay: ' . self::CUSTOM_INFO_TOTAL_COST . self::CUSTOM_INFO_CURRENCY . '.',
                    'admin' => 'New order ' . self::CUSTOM_INFO_ORDER_REFERENCE . ' amounting ' . self::CUSTOM_INFO_TOTAL_COST . self::CUSTOM_INFO_CURRENCY . ' is in ' . self::CUSTOM_INFO_ORDER_STATUS . ' status.'
                ),
                'pt' => array(
                    'client' => 'Olá, ' . self::CUSTOM_INFO_BILLING_NAME . '! Obrigado pelo seu pedido na ' . self::CUSTOM_INFO_SHOP_NAME . '. O valor é de ' . self::CUSTOM_INFO_TOTAL_COST . self::CUSTOM_INFO_CURRENCY . '. Aguardamos o pagamento.',
                    'admin' => 'O novo pedido ' . self::CUSTOM_INFO_ORDER_REFERENCE . ' de ' . self::CUSTOM_INFO_TOTAL_COST . self::CUSTOM_INFO_CURRENCY . ' está no estado ' . self::CUSTOM_INFO_ORDER_STATUS . '.'
                ),
                'es' => array(
                    'client' => 'Hola ' . self::CUSTOM_INFO_BILLING_NAME . ', Gracias por tu pedido en ' . self::CUSTOM_INFO_SHOP_NAME . '. El importe es de ' . self::CUSTOM_INFO_TOTAL_COST . self::CUSTOM_INFO_CURRENCY . '. Estamos esperando tu pago.',
                    'admin' => 'El nuevo pedido ' . self::CUSTOM_INFO_ORDER_REFERENCE . ' de ' . self::CUSTOM_INFO_TOTAL_COST . self::CUSTOM_INFO_CURRENCY . ' está en el estado ' . self::CUSTOM_INFO_ORDER_STATUS . '.'
                )
            ),
            'bankwire' => array(
                'en' => array(
                    'client' => 'Hi, ' . self::CUSTOM_INFO_BILLING_NAME . '! We\'re waiting for the payment of your order at ' . self::CUSTOM_INFO_SHOP_NAME . '. Amount to pay: ' . self::CUSTOM_INFO_TOTAL_COST . self::CUSTOM_INFO_CURRENCY . '.',
                    'admin' => 'New order ' . self::CUSTOM_INFO_ORDER_REFERENCE . ' amounting ' . self::CUSTOM_INFO_TOTAL_COST . self::CUSTOM_INFO_CURRENCY . ' is in ' . self::CUSTOM_INFO_ORDER_STATUS . ' status.'
                ),
                'pt' => array(
                    'client' => 'Olá, ' . self::CUSTOM_INFO_BILLING_NAME . '! Obrigado pelo seu pedido na ' . self::CUSTOM_INFO_SHOP_NAME . '. O valor é de ' . self::CUSTOM_INFO_TOTAL_COST . self::CUSTOM_INFO_CURRENCY . '. Aguardamos o pagamento.',
                    'admin' => 'O novo pedido ' . self::CUSTOM_INFO_ORDER_REFERENCE . ' de ' . self::CUSTOM_INFO_TOTAL_COST . self::CUSTOM_INFO_CURRENCY . ' está no estado ' . self::CUSTOM_INFO_ORDER_STATUS . '.'
                ),
                'es' => array(
                    'client' => 'Hola ' . self::CUSTOM_INFO_BILLING_NAME . ', Gracias por tu pedido en ' . self::CUSTOM_INFO_SHOP_NAME . '. El importe es de ' . self::CUSTOM_INFO_TOTAL_COST . self::CUSTOM_INFO_CURRENCY . '. Estamos esperando tu pago.',
                    'admin' => 'El nuevo pedido ' . self::CUSTOM_INFO_ORDER_REFERENCE . ' de ' . self::CUSTOM_INFO_TOTAL_COST . self::CUSTOM_INFO_CURRENCY . ' está en el estado ' . self::CUSTOM_INFO_ORDER_STATUS . '.'
                )
            ),
            'order_canceled' => array(
                'en' => array(
                    'client' => 'Hi, ' . self::CUSTOM_INFO_BILLING_NAME . '! Your order at ' . self::CUSTOM_INFO_SHOP_NAME . ' has been cancelled.',
                    'admin' => 'New order ' . self::CUSTOM_INFO_ORDER_REFERENCE . ' amounting ' . self::CUSTOM_INFO_TOTAL_COST . self::CUSTOM_INFO_CURRENCY . ' is in ' . self::CUSTOM_INFO_ORDER_STATUS . ' status.'
                ),
                'pt' => array(
                    'client' => 'Olá, ' . self::CUSTOM_INFO_BILLING_NAME . '! O pedido que fez na nossa loja ' . self::CUSTOM_INFO_SHOP_NAME . ' foi cancelado.',
                    'admin' => 'O novo pedido ' . self::CUSTOM_INFO_ORDER_REFERENCE . ' de ' . self::CUSTOM_INFO_TOTAL_COST . self::CUSTOM_INFO_CURRENCY . ' está no estado ' . self::CUSTOM_INFO_ORDER_STATUS . '.'
                ),
                'es' => array(
                    'client' => 'Hola ' . self::CUSTOM_INFO_BILLING_NAME . ', Tu pedido en nuestra tienda ' . self::CUSTOM_INFO_SHOP_NAME . ' ha sido cancelado.',
                    'admin' => 'El nuevo pedido ' . self::CUSTOM_INFO_ORDER_REFERENCE . ' de ' . self::CUSTOM_INFO_TOTAL_COST . self::CUSTOM_INFO_CURRENCY . ' está en el estado ' . self::CUSTOM_INFO_ORDER_STATUS . '.'
                )
            ),
            'payment' => array(
                'en' => array(
                    'client' => 'Hi, ' . self::CUSTOM_INFO_BILLING_NAME . '! The payment for your order at ' . self::CUSTOM_INFO_SHOP_NAME . ' has been confirmed. We\'re now processing your order. Thanks!',
                    'admin' => 'New order ' . self::CUSTOM_INFO_ORDER_REFERENCE . ' amounting ' . self::CUSTOM_INFO_TOTAL_COST . self::CUSTOM_INFO_CURRENCY . ' is in ' . self::CUSTOM_INFO_ORDER_STATUS . ' status.'
                ),
                'pt' => array(
                    'client' => 'Olá, ' . self::CUSTOM_INFO_BILLING_NAME . '! O pagamento do pedido que fez na ' . self::CUSTOM_INFO_SHOP_NAME . ' está confirmado. O pedido já está em processamento. Obrigado!',
                    'admin' => 'O novo pedido ' . self::CUSTOM_INFO_ORDER_REFERENCE . ' de ' . self::CUSTOM_INFO_TOTAL_COST . self::CUSTOM_INFO_CURRENCY . ' está no estado ' . self::CUSTOM_INFO_ORDER_STATUS . '.'
                ),
                'es' => array(
                    'client' => 'Hola ' . self::CUSTOM_INFO_BILLING_NAME . ', El pago de tu pedido en ' . self::CUSTOM_INFO_SHOP_NAME . ' fue confirmado. Estamos procesando el pedido. ¡Gracias!',
                    'admin' => 'El nuevo pedido ' . self::CUSTOM_INFO_ORDER_REFERENCE . ' de ' . self::CUSTOM_INFO_TOTAL_COST . self::CUSTOM_INFO_CURRENCY . ' está en el estado ' . self::CUSTOM_INFO_ORDER_STATUS . '.'
                )
            ),
            'preparation' => array(
                'en' => array(
                    'client' => 'Hi, ' . self::CUSTOM_INFO_BILLING_NAME . '! We\'re preparing your order at ' . self::CUSTOM_INFO_SHOP_NAME . ' for shipment. Thanks!',
                    'admin' => ''
                ),
                'pt' => array(
                    'client' => 'Olá, ' . self::CUSTOM_INFO_BILLING_NAME . '! O pedido que fez na ' . self::CUSTOM_INFO_SHOP_NAME . ' está em preparação. Obrigado!',
                    'admin' => ''
                ),
                'es' => array(
                    'client' => 'Hola ' . self::CUSTOM_INFO_BILLING_NAME . ', Estamos preparando el envío de tu pedido en ' . self::CUSTOM_INFO_SHOP_NAME . '. ¡Gracias!',
                    'admin' => ''
                )
            ),
            'refund' => array(
                'en' => array(
                    'client' => 'Hi, ' . self::CUSTOM_INFO_BILLING_NAME . '! We\'ve just refunded your order at ' . self::CUSTOM_INFO_SHOP_NAME . '.',
                    'admin' => 'New order ' . self::CUSTOM_INFO_ORDER_REFERENCE . ' amounting ' . self::CUSTOM_INFO_TOTAL_COST . self::CUSTOM_INFO_CURRENCY . ' is in ' . self::CUSTOM_INFO_ORDER_STATUS . ' status.'
                ),
                'pt' => array(
                    'client' => 'Olá, ' . self::CUSTOM_INFO_BILLING_NAME . '! Fizemos o reembolso do valor do seu pedido na nossa loja ' . self::CUSTOM_INFO_SHOP_NAME . '.',
                    'admin' => 'O pedido ' . self::CUSTOM_INFO_ORDER_REFERENCE . ' de ' . self::CUSTOM_INFO_TOTAL_COST . self::CUSTOM_INFO_CURRENCY . ' está no estado ' . self::CUSTOM_INFO_ORDER_STATUS . '.'
                ),
                'es' => array(
                    'client' => 'Hola ' . self::CUSTOM_INFO_BILLING_NAME . ', Hemos finalizado la devolución del importe de tu pedido en ' . self::CUSTOM_INFO_SHOP_NAME . '.',
                    'admin' => 'El pedido ' . self::CUSTOM_INFO_ORDER_REFERENCE . ' de ' . self::CUSTOM_INFO_TOTAL_COST . self::CUSTOM_INFO_CURRENCY . ' está en el estado ' . self::CUSTOM_INFO_ORDER_STATUS . '.'
                )
            ),
            'outofstock' => array(
                'en' => array(
                    'client' => 'Hi, ' . self::CUSTOM_INFO_BILLING_NAME . '! Unfortunately the item you chose at ' . self::CUSTOM_INFO_SHOP_NAME . ' is out of stock. We\'ll contact you soon about it.',
                    'admin' => 'New order ' . self::CUSTOM_INFO_ORDER_REFERENCE . ' amounting ' . self::CUSTOM_INFO_TOTAL_COST . self::CUSTOM_INFO_CURRENCY . ' is in ' . self::CUSTOM_INFO_ORDER_STATUS . ' status.'
                ),
                'pt' => array(
                    'client' => 'Olá, ' . self::CUSTOM_INFO_BILLING_NAME . '! Infelizmente o produto que escolheu na ' . self::CUSTOM_INFO_SHOP_NAME . ' está esgotado. Aguarde o nosso contato.',
                    'admin' => 'O pedido ' . self::CUSTOM_INFO_ORDER_REFERENCE . ' de ' . self::CUSTOM_INFO_TOTAL_COST . self::CUSTOM_INFO_CURRENCY . ' está no estado ' . self::CUSTOM_INFO_ORDER_STATUS . '.'
                ),
                'es' => array(
                    'client' => 'Hola ' . self::CUSTOM_INFO_BILLING_NAME . ', Lamentablemente el producto que elegiste en ' . self::CUSTOM_INFO_SHOP_NAME . ' está agotado. Te contactaremos pronto.',
                    'admin' => 'El pedido ' . self::CUSTOM_INFO_ORDER_REFERENCE . ' de ' . self::CUSTOM_INFO_TOTAL_COST . self::CUSTOM_INFO_CURRENCY . ' está en el estado ' . self::CUSTOM_INFO_ORDER_STATUS . '.'
                )
            ),
            self::PAYMENT_STATUS_WAITING_MB_PAYMENT => array(
                'en' => array(
                    'client' => 'Hi, ' . self::CUSTOM_INFO_BILLING_NAME . '! MB payment details for your order at ' . self::CUSTOM_INFO_SHOP_NAME . '. Ent.: ' . self::CUSTOM_INFO_ENTITY . ' Ref.: ' . self::CUSTOM_INFO_MB_REFERENCE . ' Amount: ' . self::CUSTOM_INFO_TOTAL_COST . self::CUSTOM_INFO_CURRENCY . ' Thanks!',
                    'admin' => 'New order ' . self::CUSTOM_INFO_ORDER_REFERENCE . ' amounting ' . self::CUSTOM_INFO_TOTAL_COST . self::CUSTOM_INFO_CURRENCY . ' is in %order_status% status.'
                ),
                'pt' => array(
                    'client' => 'Olá, ' . self::CUSTOM_INFO_BILLING_NAME . '! Aguardamos o pagamento por MB do pedido que fez na ' . self::CUSTOM_INFO_SHOP_NAME . '. Ent.: ' . self::CUSTOM_INFO_ENTITY . ' Ref.: ' . self::CUSTOM_INFO_MB_REFERENCE . ' Valor: ' . self::CUSTOM_INFO_TOTAL_COST . self::CUSTOM_INFO_CURRENCY . ' Obrigado!',
                    'admin' => 'O novo pedido ' . self::CUSTOM_INFO_ORDER_REFERENCE . ' de ' . self::CUSTOM_INFO_TOTAL_COST . self::CUSTOM_INFO_CURRENCY . ' está no estado ' . self::CUSTOM_INFO_ORDER_STATUS . '.'
                ),
                'es' => array(
                    'client' => 'Hola ' . self::CUSTOM_INFO_BILLING_NAME . ', Datos para el pago vía MB de tu pedido en ' . self::CUSTOM_INFO_SHOP_NAME . '. Ent.: ' . self::CUSTOM_INFO_ENTITY . ' Ref.: ' . self::CUSTOM_INFO_MB_REFERENCE . ' Importe: ' . self::CUSTOM_INFO_TOTAL_COST . self::CUSTOM_INFO_CURRENCY . ' ¡Gracias!',
                    'admin' => 'El nuevo pedido ' . self::CUSTOM_INFO_ORDER_REFERENCE . ' de ' . self::CUSTOM_INFO_TOTAL_COST . self::CUSTOM_INFO_CURRENCY . ' está en el estado ' . self::CUSTOM_INFO_ORDER_STATUS . '.'
                )
            )
        );
    }

    private static function createMultiLangField($field) {

		$languages = Language::getLanguages(false);
		$res = array();
		foreach ($languages as $lang)
		    $res[$lang['id_lang']] = $field;
		return $res;
   	}

	private static function createMultiLangFieldHard($res) {

		$languages = Language::getLanguages(false);
		foreach ($languages as $lang) {
		    if(!array_key_exists($lang['id_lang'], $res))
		        $res[$lang['id_lang']] = $res['1'];
		}
		return $res;
	}

	private function serviceActivate($email, $option = false, $valid = '', $client = ''){

		try{

			$call = '';
			$extra = '';
			if($option == 'enable'){
				$call = 1;
				$option = false;
			}else{
				if(is_string($option)){
					$option = false;
					$extra = 1;
				}
			}

			$id = $this->context->cookie->id_lang;
			$lang = $this->getLang($id);

			$params = array(
				'email' => $email,
				'smegoi_c' => $client,
				'smegoi_v' => 'PrestaShop_'.$this->version,
				'smegoi_h' => isset($_SERVER['SERVER_NAME']) ? $_SERVER['SERVER_NAME'] : $_SERVER['HTTP_HOST'],
				'smegoi_e' => $lang, 
				'smegoi_m' => $extra ? $extra : '',
				'smegoi_i' => $valid
			);

			require('includes/post_wsdl.php');
			if(class_exists("SoapClient")){
				$response = new SoapClient(NULL, $options);
				$response->call($params, $call, $extra);
			}

		}catch(Exception $e){
			//continue
		}

		return '';
	}

	private function getLang($id){

		$sql = 'SELECT name FROM '._DB_PREFIX_.'lang WHERE id_lang="'.(int)$id.'"';
		$rows = Db::getInstance()->execute($sql);

		return $rows[0]['name'];
	}

		/**
    * Enable/Activate module.
    *
    * @param bool $forceAll If true, enable module for all shop
    */
    public function enable($forceAll = false) {
    	
		$email = $this->context->cookie->email;
  		$this->serviceActivate($email, __FUNCTION__);
        return parent::enable($forceAll);
    }

    /**
    * Disable/Deactivate module.
    *
    * @param bool $forceAll If true, disable module for all shop
    */
    public function disable($forceAll = false) {

    	$email = $this->context->cookie->email;
  		$this->serviceActivate($email, __FUNCTION__);
        return parent::disable($forceAll);
    }


    /**
    * Hooks functions.
    *
    * @param array $params
    */
    public function hookActionObjectCustomerAddAfter($params) {

		return $this->customerAdd($params);
	}

	public function sql_list(){

		$sql = 'SELECT list_id, sync, total FROM '._DB_PREFIX_.'egoi WHERE client_id != "" order by egoi_id DESC limit 1';
		$row = Db::getInstance(_PS_USE_SQL_SLAVE_)->execute($sql);
		return $row[0];
	}

	private function customerAdd($params){

        if ($params['object']->newsletter == 1) {
            $customer = $params['object']->email;
            $fname = $params['object']->firstname;
            $lname = $params['object']->lastname;
            $birthday = $params['object']->birthday;
            $newsletter = $params['object']->newsletter;
            $optin = $params['object']->optin;

            require($this->api_class);
            $api = new EgoiAPIV2();

            $all_fields = array(
                'email' => $customer,
                'firstname' => $fname,
                'lastname' => $lname,
                'birthday' => $birthday,
                'newsletter' => $newsletter,
                'optin' => $optin
            );

            foreach ($all_fields as $key => $value) {
                $row = $api->getFieldMap(0, $key);

                if ($row) {
                    $fields[$row] = $value;
                }
            }

            $client_data = $api->getClientData();
            $client = (int)$client_data['CLIENTE_ID'];

            $sql = 'SELECT list_id, sync, total FROM ' . _DB_PREFIX_ . 'egoi WHERE client_id=' . $client;
            $get_sync = Db::getInstance(_PS_USE_SQL_SLAVE_)->execute($sql);
            $list_id = $get_sync[0]['list_id'];
            $sync = $get_sync[0]['sync'];
            $subs = $get_sync[0]['total'];
            $doptin = $get_sync[0]['doptin'];

            if ($sync == '1') {

                if ($doptin == '1') {
                    $formID = $get_sync[0]['form_id'];
                }

                if ($newsletter == '0') {

                    $name = 'NO_Newsletter';
                    $get_tags = $api->getTags($name);

                    if ($get_tags['NAME'] != $name) {
                        $add_tag = $api->addTag($name);
                        $tag = $add_tag['ID'];
                    } else {
                        $tag = '';
                        foreach ($get_tags as $tags) {
                            if ($tags['NAME'] == $name)
                                $tag = $tags['ID'];
                        }

                    }
                }

                $add = $api->addSubscriberForm($list_id, $customer, $fname, $lname, false, $formID, $tag, $fields);
                if ($add['ERROR']) {
                    return false;
                } else {
                    $where = "client_id = $client";
                    $sql_insert = array(
                        'total' => (int)($subs + 1)
                    );
                    Db::getInstance()->update('egoi', $sql_insert, $where);
                }

            } else {
                return false;
            }
        } else {
            return false;
        }
	}

	public function customerDelete(){

		$sql = $this->sql_list();
		$sync = $sql['sync'];

		if($sync) {

			if(Tools::isSubmit('submitBulkdeletecustomer')) {

				$customer = array();
				$list = $sql['list_id'];
				$ids = $_POST['customerBox'];
				foreach ($ids as $key => $id_customer) {
					$customer[] = new Customer((int)$id_customer);
				}
				
				require($this->api_class);
				$api = new EgoiAPIV2();
				foreach ($customer as $key => $email) {

					$rm = $api->removeSubscriber($list, $email->email);
					
					if(!$rm['ERROR']){
						$subs = $sql['total'];

						$client_data = $api->getClientData();
						$client = (int)$client_data['CLIENTE_ID'];

						$where = "client_id = $client";
						$sql_insert = array(
							'total' => (int)($subs-1)
						);
						Db::getInstance()->update('egoi', $sql_insert, $where);
					}
				}

			}
		}
	}

	public function customerUpdate(){

		$sql = $this->sql_list();
		$sync = $sql['sync'];

		if($sync) {

			$id = isset($_GET['id_customer']) ? $_GET['id_customer'] : '';
			if($id) {
				$customer= new Customer((int)$id);
				
				$email = $customer->email;
				$fname = $customer->firstname;
				$lname = $customer->lastname;
				$birthday = $customer->birthday;
				$newsletter = $customer->newsletter;
				$optin = $customer->optin;

				require($this->api_class);
				$api = new EgoiAPIV2();

				$all_fields = array(
					'email' => $email,
					'firstname' => $fname,
					'lastname' => $lname,
					'birthday' => $birthday,
					'newsletter' => $newsletter,
					'optin' => $optin
				);

				foreach ($all_fields as $key => $value) {
					$row = $api->getFieldMap(0, $key);

					if($row){
						$fields[$row] = $value;
					}
				}
				
				$list = $sql['list_id'];
				$api->editSubscriber($list, $email, $fname, $lname, $fields);
			}

		}
	}

	public function sqlTrack(){

		$sql = 'SELECT * FROM '._DB_PREFIX_.'egoi WHERE client_id != "" and track="1" order by egoi_id DESC limit 1';
		$rq = Db::getInstance(_PS_USE_SQL_SLAVE_)->execute($sql);

		return $rq[0];
	}

	/*
	*	Add to cart hooks
	*/
	public function hookActionCartSave($params) {

		$this->hookAddToCart($params);
	}

	public function hookCart($params) {

		$this->hookAddToCart($params);
	}

	private function getCustomerId() {

		$idc = (int)($this->context->cookie->id_customer);
		if(!$idc) {
			$idc = session_id();
		}
		return $idc;
	}

	public function hookAddToCart($params) {

		if(is_array($params['json'])){
	 		$json = json_decode($params['json']['id']);
	 	}

	 	if(!$json){
	 		//$json = $params['cart']->id;
	 		$json = $params['cookie']->id_cart;
	 	}

	 	$sql = $this->sqlTrack();
	 	$list_id = $sql['list_id'];
		$track = $sql['track'];
		$client = $sql['client_id'];
		if($client && $track && $list_id){

			// check if customer has products in the cart (has cart ID?)
			if(isset($json) && ($json)) {
				$idc = $this->getCustomerId();

				$sql_update = array(
					'customer' => $idc,
					'id_cart' => (int)$json,
					'estado' => 1
				);

				$result = $this->customersSQL($idc);
				$res = $result[0];

				if(empty($res)) {
					Db::getInstance()->insert('egoi_customers', $sql_update);
				}
			}
		}
	}

	public function customersSQL($idc) {

		$sql = "SELECT id_cart FROM "._DB_PREFIX_."egoi_customers WHERE customer='".$idc."'";
		$getCart = Db::getInstance(_PS_USE_SQL_SLAVE_)->execute($sql);
		return $getCart;
	}

	public function deployCartAndPageView() {

		$idc = $this->getCustomerId();

		$getCart = $this->customersSQL($idc);

		$sql = $this->sqlTrack();
		$list_id = $sql['list_id'];
		$client = $sql['client_id'];
		$track = $sql['track'];
		if($client && $list_id && $track){

			$customer = $this->context->cookie->email;

			$cart = new Cart($getCart[0]['id_cart']);
			$products = $cart->getProducts();

			$this->removeCart();

			include('includes/TrackEngage.php');
			return $te;
		}

		return false;
	}

	public function getOrder($id) {

		$sql = "SELECT * FROM "._DB_PREFIX_."orders WHERE id_cart='".(int)$id."' OR id_order='".(int)$id."'";
		$view = Db::getInstance(_PS_USE_SQL_SLAVE_)->execute($sql);
		return $view[0];
	}

	/*
	* 	Remove cart on order
	*/
	private function removeCart() {

		$idc = $this->getCustomerId();
		$sql = "DELETE FROM "._DB_PREFIX_."egoi_customers WHERE customer='".$idc."'";
		return Db::getInstance(_PS_USE_SQL_SLAVE_)->execute($sql);
	}

	/*
	*	Confirm order and payment hook
	*/
	public function finalOrder() {

		$sql = $this->sqlTrack();
		$list_id = $sql['list_id'];
		$track = $sql['track'];
		$client = $sql['client_id'];

		if($client && $track && $list_id){

			$cart = new Cart($_GET['id_cart']);
			$customer = $this->context->cookie->email;

			$order = $this->getOrder($_GET['id_order']);
			$order_id = $order['reference'];
			$order_total = number_format($order['total_paid'],0);
			$order_subtotal = number_format($order['total_paid_tax_excl'],0);
			$order_tax = number_format($order['total_shipping'],1);
			$order_shipping = number_format($order['total_wrapping'],1);
			$order_discount = $order['total_discounts'];
			$products = $cart->getProducts();

			include('includes/TrackEngage.php');

			$this->assign(
		      	array(
		          	'te' => $te,
	          		'activate' => 1
		      	)
		  	);
			
			$_SESSION['order'] = 1;
			$this->removeCart();
		}
	}


	public function hookDisplayTop($params){

		if(isset($_SESSION['order']) && ($_SESSION['order'])) {
			unset($_SESSION['order']);
		}
		else{

			$te = $this->deployCartAndPageView();
			$this->assign(
		      	array(
		          	'te' => $te,
		          	'activate' => 1
		      	)
		  	);

			$sql = 'SELECT * FROM '._DB_PREFIX_.'egoi_forms WHERE block_header="1" LIMIT 1';
			$rq = Db::getInstance(_PS_USE_SQL_SLAVE_)->execute($sql);
			$enable = $rq[0]['enable'];
			$form_id = $rq[0]['form_id'];
			$form_title = $rq[0]['form_title'];
			$content = $rq[0]['content'];
			$bootstrap = $rq[0]['boot'];
			$block_header = $rq[0]['block_header'];
			$url = $rq[0]['url'];
			$form_type = $rq[0]['form_type'];

			$width = $rq[0]['style_width'];
			$height = $rq[0]['style_height'];

			if($enable){

				if($form_type == 'iframe'){
					$content = '<iframe src="http://'.$url.'" width="'.$width.'" height="'.$height.'" style="border: 0 none;" onload="window.parent.parent.scrollTo(0,0);"></iframe>';
				}else{
					$content = html_entity_decode($content);
				}

				$this->assign(
			      	array(
			          'form_id' => $form_id,
			          'bootstrap' => $bootstrap,
			          'form_title' => $form_title,
			          'content' => $content,
			          'header' => $block_header,
			          'form_type' => $form_type
			      	)
			  	);

				return $this->display(__FILE__, 'egoiforps.tpl');
			}
		}

		return $this->display(__FILE__, 'track_engage.tpl');
	}

	public function hookDisplayFooter($params){

		$sql = 'SELECT * FROM '._DB_PREFIX_.'egoi_forms WHERE block_footer="1" LIMIT 1';
		$rq = Db::getInstance(_PS_USE_SQL_SLAVE_)->execute($sql);
		$enable = $rq[0]['enable'];
		$form_id = $rq[0]['form_id'];
		$form_title = $rq[0]['form_title'];
		$content = $rq[0]['content'];
		$bootstrap = $rq[0]['boot'];
		$block_footer = $rq[0]['block_footer'];
		$url = $rq[0]['url'];
		$form_type = $rq[0]['form_type'];

		$width = $rq[0]['style_width'];
		$height = $rq[0]['style_height'];

		if($enable){

			if($form_type == 'iframe'){
				$content = '<iframe src="http://'.$url.'" width="600" height="400" style="border: 0 none;" onload="window.parent.parent.scrollTo(0,0);"></iframe>';
			}else{
				$content = html_entity_decode($content);
			}

			$this->assign(
		      	array(
		          'form_id' => $form_id,
		          'bootstrap' => $bootstrap,
		          'form_title' => $form_title,
		          'content' => $content,
		          'footer' => $block_footer,
		      	)
		  	);

			return $this->display(__FILE__, 'egoiforps.tpl');
		}
	}

	public function hookDisplayHome($params){

		$sql = 'SELECT * FROM '._DB_PREFIX_.'egoi_forms WHERE block_home="1" LIMIT 1';
		$rq = Db::getInstance(_PS_USE_SQL_SLAVE_)->execute($sql);
		$enable = $rq[0]['enable'];
		$form_id = $rq[0]['form_id'];
		$form_title = $rq[0]['form_title'];
		$content = $rq[0]['content'];
		$bootstrap = $rq[0]['boot'];
		$popup = $rq[0]['popup'];
		$url = $rq[0]['url'];
		$form_type = $rq[0]['form_type'];

		$width = $rq[0]['style_width'];
		$height = $rq[0]['style_height'];

		if($popup) $once = $rq[0]['once'];

		if($enable){

	  		if($form_type == 'iframe'){
				$content = '<iframe src="http://'.$url.'" width="600" height="400" style="border: 0 none;" onload="window.parent.parent.scrollTo(0,0);"></iframe>';
			}else{
				$content = html_entity_decode($content);
			}

			$this->assign(
		      	array(
		          'form_id' => $form_id,
		          'bootstrap' => $bootstrap,
		          'form_title' => $form_title,
		          'content' => $content,
		          'popup' => $popup,
		          'once' => $once
		      	)
		  	);

			return $this->display(__FILE__, 'egoiforps.tpl');
		}
	}

	public function postFrontForm($post) {

		require($this->api_class);

		$form = $post['form_id'];
		$email = $post['email'];
		$fname = $post['fname'];
		$lname = $post['lname'];
		$phone = $post['phone_number'];

		$sql_form = "SELECT * FROM "._DB_PREFIX_."egoi_forms WHERE form_id='".(int)$form."'";
		$getform = Db::getInstance(_PS_USE_SQL_SLAVE_)->execute($sql_form);

		$list = $getform[0]['list_id'];
		$doptin = $getform[0]['doptin'];

		$success = $getform[0]['success'];
		$msg_gen = $getform[0]['msg_gen'];
		$msg_invalid = $getform[0]['msg_invalid'];
		$msg_exists = $getform[0]['msg_exists'];
		$redirect = $getform[0]['redirect'];
		$hide = $getform[0]['hide'];
		$popup = $getform[0]['popup'];
		$url = $getform[0]['url'];

		$api = new EgoiAPIV2();
		$sub_data = $api->getSubscriber($list, $email);

		if($doptin == '1'){
			$formID = $getform[0]['formID_egoi'];
		}

		if($sub_data['ERROR'] != '') {
			$add = $api->addSubscriberForm($list, $email, $fname, $lname, $phone, $formID);
			$error = $add['ERROR'];

				if($error){

					if($msg_gen){
						$error_submit = $msg_gen;
					}else{
						$error_submit = $error;
					}

				}else{
					if($redirect){
						header('Location: '.$redirect);
						exit;
					}else{

						if($success){
							$success_submit = $success;
						}else{
							$success_submit = 'Form Submited with Success';
						}

					}
				}

		}else{

			if($msg_exists){
				$error_submit = $msg_exists;
			}else{
				$error_submit = $error;
			}
		}

			$this->assign(
		      	array(
		          'form_id' => $form_id,
		          'bootstrap' => $bootstrap,
		          'form_title' => $form_title,
		          'popup' => $popup
		      	)
		  	);

		if($success_submit){

			/*$insert_customer = array(
				'id_shop_group' => 1,
				'id_shop' => 1,
				'id_default_group' => 1,
				'firstname' => $fname ? $fname : 'No First Name',
				'lastname' => $lname ? $lname : 'No Last Name',
				'email' => $email,
				'passwd' => '12345',
				'newsletter' => 1,
				'active' => 1,
				'is_guest' => 1,
			);
			Db::getInstance()->insert('customer', $insert_customer);*/

			//E-GOI FORM
			$content = '<iframe src="http://'.$url.'" width="600" height="400" style="border: 0 none;" onload="window.parent.parent.scrollTo(0,0);"></iframe>';

			if($hide){
				$api_key = Configuration::get('egoi_api_key');
				if($api_key){
					$this->assign('ShowApiKeyWarn', false);
					$this->assign('form_id', $form);
				}

				//redirecciona para o template
				$this->display(__FILE__, 'egoiforps.tpl');
			}else{
				//if success
				$this->assign('content', $content);

				$this->assign('success_submit', $success_submit);
				$this->display(__FILE__, 'egoiforps.tpl');
			}

		}else{
			//if error
			$this->assign('content', $content);
			$this->assign('error_submit', $error_submit);
			$this->display(__FILE__, 'egoiforps.tpl');
		}
	}

	public function hookDisplayHeader() {

	  	$this->context->controller->addCSS($this->_path.'views/templates/front/css/main.css', 'all');
	  	$this->context->controller->addCSS('http://maxcdn.bootstrapcdn.com/bootstrap/3.3.6/css/bootstrap.min.css', 'all');
	  	//$this->context->controller->addJS($this->_path.'views/templates/front/js/custom.js', 'all');
	}

	public function hookDisplayBackOfficeHeader() {

	   	$this->context->controller->addCss($this->_path.'views/css/admin/tab.css');
	}


	/**
	 * [getContentURL API Key]
	 * @return url
	 */
	private function getContentURL($url){

        if(ini_get('allow_url_fopen') == true){

        	$context = stream_context_create(array('http' => array( 'timeout' => 600)));
            $result = file_get_contents($url, false, $context);

        } else if(function_exists('curl_init')) {

            $curl = curl_init();
            curl_setopt($curl,CURLOPT_URL,$url);
            curl_setopt($curl,CURLOPT_HEADER,0);
            curl_setopt($curl,CURLOPT_RETURNTRANSFER,1);
            curl_setopt($curl,CURLOPT_CONNECTTIMEOUT,600);
            curl_setopt($curl,CURLOPT_TIMEOUT,60);
            curl_setopt($curl,CURLOPT_RETURNTRANSFER,1);
            $result = curl_exec($curl);
            curl_close($curl);

        } else {
            throw new Exception("ERROR");
        }

        return $result;
	}

	public function addClientId($post) {
		$client_id = $post['egoi_client_id'];
		$query = 'TRUNCATE TABLE '._DB_PREFIX_.'egoi';
		Db::getInstance()->execute($query);

		$sql = array(
			'client_id' => $client_id
		);
		Db::getInstance()->insert('egoi', $sql);
		return true;
	}

	public function validateApiKey(){

		$key = isset($_POST["api_key"]) ? $_POST["api_key"] : '';
		if(isset($key) && ($key)){

	        $url = 'http://api.e-goi.com/v2/rest.php?type=json&method=getClientData&'.http_build_query(array('functionOptions' => array('apikey' => $key)),'','&');
	        $result_client = json_decode($this->getContentURL($url));

	        if($result_client->Egoi_Api->getClientData->response=='INVALID'){
	        	header('HTTP/1.1 403 Forbidden');
				exit;
	        }else{
	        	echo json_encode($result_client->Egoi_Api->getClientData);
	        	exit;
	        }
		}
	}


	private function sincronizeList($post){

		$subs = $post["subs"];
		if($subs){

	    	$sql = 'SELECT list_id, client_id, sync FROM '._DB_PREFIX_.'egoi WHERE client_id != "" and sync="1" order by egoi_id DESC limit 1';
	        $get_sync = Db::getInstance(_PS_USE_SQL_SLAVE_)->execute($sql);
	        $sync = $get_sync[0]['sync'];
	        $client_id = $get_sync[0]['client_id'];
	        $list_id = $get_sync[0]['list_id'];

	        if($sync){

	            $sqlc = 'SELECT email, firstname, lastname, birthday, newsletter, optin FROM '._DB_PREFIX_.'customer WHERE active="1" AND newsletter="1"';
	            $getcs = Db::getInstance(_PS_USE_SQL_SLAVE_)->execute($sqlc);
	            
	            require($this->api_class);
	            $api = new EgoiAPIV2();

	            $name = 'NO_Newsletter';
	            $get_tags = $api->getTags($name);
	            
	            if($get_tags['NAME'] != $name){
	                $add_tag = $api->addTag($name);
	                $tag = $add_tag['ID'];
	            }else{
	                $tag = '';
	                foreach ($get_tags as $tags){
	                    if($tags['NAME'] == $name){
	                        $tag = $tags['ID'];
	                    }
	                }
	            }

	            $array = array();
	            $subscribers = array();

	            foreach($getcs as $row){   

	                $all_fields = array(
	                    'email' => $row['email'],
	                    'firstname' => $row['firstname'],
	                    'lastname' => $row['lastname'],
	                    'birthday' => $row['birthday'],
	                    'newsletter' => date('Y-m-d', strtotime($row['newsletter'])),
	                    'optin' => $row['optin']
	                );

	                $subscribers['status'] = 1;
	                $subscribers['email'] = $row['email'];
	                $subscribers['cellphone'] = '';
	                $subscribers['fax'] = '';
	                $subscribers['telephone'] = '';
	                $subscribers['first_name'] = $row['firstname'];
	                $subscribers['last_name'] = $row['lastname'];
	                $subscribers['birth_date'] = date('Y-m-d', strtotime($row['birthday']));
	                $subscribers['lang'] = '';

	                foreach ($all_fields as $key => $value) {
	                    $row_new_value = $api->getFieldMap(0, $key);

	                    if($row_new_value){
	                        $subscribers[$row_new_value] = $value;
	                    }
	                }

	                $array[] = $subscribers;
	            }

	            $api->addSubscriberBulk($list_id, $array, $tag);
	           
	            $subs = $api->getAllSubscribers($list_id);
	            $where = "client_id = $client_id";
	            $sql_insert = array(
	                'total' => (int)$subs
	            );
	            Db::getInstance()->update('egoi', $sql_insert, $where);

	        }

	        return $subs;

		}else{
			header('HTTP/1.1 403 Forbidden');
			exit;
		}
	}

    public function hookActionDispatcher($params)
    {
        $this->triggerReminders();
    }

    public function hookActionOrderStatusPostUpdate($params)
    {
        return $this->sendSmsNotification($params);
    }

    private function triggerReminders()
    {
        //Server time. Perhaps retrieve it from store?
        $time = time();
        $hour = $time / 3600 % 24;

        if ($hour > self::LIMIT_HOUR_MIN && $hour < self::LIMIT_HOUR_MAX) {
            $reminders = Db::getInstance()->executeS("SELECT * FROM " . _DB_PREFIX_ . "egoi_sms_notif_order_reminder");
            foreach ($reminders as $reminder) {
                if ($time >= $reminder['send_date']) {
                    $this->sendReminder($reminder['mobile'], $reminder['message'], $reminder['order_id']);
                }
            }
        }
    }

    private function sendReminder($mobile, $message, $orderId)
    {
        $senderHash = Configuration::get(self::SMS_NOTIFICATIONS_SENDER_CONFIGURATION);
        $this->transactionalApi->sendSms($mobile, $senderHash, $message);
        $this->deleteReminder($orderId);
    }

    private function deleteReminder($orderId)
    {
        $orderId = pSQL($orderId);
        Db::getInstance()->delete('egoi_sms_notif_order_reminder', "order_id=$orderId");
    }

    private function sendSmsNotification($params)
    {
        if (!Configuration::hasKey(self::SMS_NOTIFICATIONS_SENDER_CONFIGURATION)) {
            return false;
        }

        $order = new Order($params['id_order']);
        $newOrderStatus = $params['newOrderStatus'];
        $smsNotif = Db::getInstance()->getRow("SELECT * FROM "._DB_PREFIX_."egoi_sms_notif_order_status WHERE order_status_id=".pSQL($newOrderStatus->id));
        $send = $smsNotif['send_client'] == 1;
        $this->sendClient($newOrderStatus, $order, $send);

        $admin = Configuration::get(self::SMS_NOTIFICATIONS_ADMINISTRATOR_CONFIGURATION);
        if (!empty($admin) && $smsNotif['send_admin'] == 1) {
            return $this->sendAdmin($params['newOrderStatus'], $order, $admin);
        }

        return true;
    }

    private function sendClient($newOrderStatus, $order, $send)
    {
        $senderHash = Configuration::get(self::SMS_NOTIFICATIONS_SENDER_CONFIGURATION);

        $messages = $this->getNotifMessages($newOrderStatus->id, $order->id_lang);
        $message = $this->parseMessage($messages['client_message'], $newOrderStatus, $order);
        if ($send && empty($message)) {
            return false;
        }

        $addresses = array();
        if (!empty(Configuration::get(self::SMS_NOTIFICATIONS_DELIVERY_ADDRESS_CONFIGURATION))) {
            array_push($addresses, new Address($order->id_address_delivery));
        }
        if (!empty(Configuration::get(self::SMS_NOTIFICATIONS_INVOICE_ADDRESS_CONFIGURATION))) {
            array_push($addresses, new Address($order->id_address_invoice));
        }

        $sent = array();
        foreach ($addresses as $address) {
            $mobile = $this->getPhoneFromOrder($address);
            if (!$mobile) {
                return false;
            }

            $country = new Country($address->id_country);
            $mobile = $country->call_prefix . '-' . $mobile;
            if (isset($sent[$mobile])) {
                continue;
            }

            $sent[$mobile] = 1;
            if ($send) {
                $this->transactionalApi->sendSms($mobile, $senderHash, $message);
            }

            $this->reminder($order, $newOrderStatus, $mobile);
        }

        return true;
    }

    private function sendAdmin($newOrderStatus, $order, $admin)
    {
        $senderHash = Configuration::get(self::SMS_NOTIFICATIONS_SENDER_CONFIGURATION);

        $messages = empty($messages) ? $this->getNotifMessages($newOrderStatus->id, $order->id_lang) : $messages;
        $message = $this->parseMessage($messages['admin_message'], $newOrderStatus, $order);
        if (empty($message)) {
            return false;
        }

        $mobile = Configuration::get(self::SMS_NOTIFICATIONS_ADMINISTRATOR_PREFIX_CONFIGURATION) . '-' . $admin;
        $this->transactionalApi->sendSms($mobile, $senderHash, $message);

        return true;
    }

    private function getNotifMessages($orderStatusId, $langId)
    {
        return Db::getInstance()->getRow("SELECT client_message,admin_message FROM "._DB_PREFIX_.
            "egoi_sms_notif_messages WHERE order_status_id=" .pSQL($orderStatusId). " AND lang_id=".pSQL($langId)
        );
    }

    private function parseMessage($message, $orderStatus, $order)
    {
        $currency = new Currency($order->id_currency);
        $mb = $this->getMbData($order, $orderStatus);
        $customer = new Customer($order->id_customer);

        return str_replace(
            [
                self::CUSTOM_INFO_ORDER_REFERENCE,
                self::CUSTOM_INFO_ORDER_STATUS,
                self::CUSTOM_INFO_TOTAL_COST,
                self::CUSTOM_INFO_CURRENCY,
                self::CUSTOM_INFO_ENTITY,
                self::CUSTOM_INFO_MB_REFERENCE,
                self::CUSTOM_INFO_SHOP_NAME,
                self::CUSTOM_INFO_BILLING_NAME
            ],
            [
                $order->reference,
                $orderStatus->name,
                $mb['total_cost'],
                $currency->sign,
                $mb['entity'],
                $mb['reference'],
                Configuration::get('PS_SHOP_NAME'),
                $customer->firstname . ' ' . $customer->lastname
            ],
            $message
        );
    }

    private function reminder($order, $orderState, $mobile)
    {
        if (self::getPaymentModule($orderState)) {
            $message = $this->getReminderMessage($orderState->id, $order->id_lang)['message'];
            if (empty($message)) {
                return;
            }

            $message = $this->parseMessage($message, $orderState, $order);
            if (!empty($message)) {
                Db::getInstance()->insert(
                    'egoi_sms_notif_order_reminder',
                    array(
                        'order_id' => pSQL($order->id),
                        'mobile' => pSQL($mobile),
                        'send_date' => time() + Configuration::get(self::SMS_REMINDER_DEFAULT_TIME_CONFIG) * 3600,
                        'message' => pSQL($message)
                    )
                );
            }
        } else {
            $this->deleteReminder($order->id);
        }
    }

    private function getReminderMessage($orderStatusId, $langId)
    {
        return Db::getInstance()->getRow("SELECT message FROM "._DB_PREFIX_.
            "egoi_sms_notif_reminder_messages WHERE order_status_id=".pSQL($orderStatusId)
            ." AND lang_id=".pSQL($langId)
            ." AND active=1"
        );
    }

    private function getPhoneFromOrder($address)
    {
        if (!empty($address->phone_mobile)) {
            return $address->phone_mobile;
        } elseif (!empty($address->phone)) {
            return $address->phone;
        }

        return false;
    }

    private function getMbData($order, $orderState)
    {
        $data = array('entity' => '', 'reference' => '', 'total_cost' => $order->total_paid);
        $paymentModule = self::getPaymentModule($orderState);
        switch ($paymentModule) {
            case 'multibanco':
                $data = $this->getIfThenPayData($order);
                break;
            case 'eupago_multibanco':
                $data = $this->getEuPagoData($order);
                break;
            default:
        }

        return $data;
    }

    private function getIfThenPayData($order)
    {
        $module = Module::getInstanceByName('multibanco');
        $details = $module->getMBDetails();
        $total = $order->getOrdersTotalPaid();
        $ref = $module->GenerateMbRef($details[0], $details[1], $order->id, $total);

        return $this->buildMbArray($details[0], $ref, $total, $order->id_currency);
    }

    private function getEuPagoData($order)
    {
        $module = Module::getInstanceByName('eupago_multibanco');
        $result = $module->GenerateReference($order);

        $entity = '';
        $ref = '';
        $total = $order->total_paid;
        if ($result->estado == 0) {
            $entity = $result->entidade;
            $ref = $result->referencia;
            $total = $result->valor;
        }

        return $this->buildMbArray($entity, $ref, $total, $order->id_currency);
    }

    private function buildMbArray($entity, $ref, $total, $currency)
    {
        $data = array();
        $data['entity'] = $entity;
        $data['reference'] = $ref;
        $data['total_cost'] = Tools::displayPrice($total, new Currency($currency), false);

        return $data;
    }
}
